--
--  File: C:\MyDesign\Fndtn15\drivers\COMP\Fsm.vhd
-- created: 07/13/99 10:28:44
--  from: 'C:\MyDesign\Fndtn15\drivers\COMP\Fsm.asf'
--  by fsm2hdl - version: 2.0.1.52
--
library IEEE;
use IEEE.std_logic_1164.all;

use IEEE.std_logic_arith.all;
use IEEE.std_logic_unsigned.all;

library SYNOPSYS;
use SYNOPSYS.attributes.all;

entity fsm is 
  port (clock: in STD_LOGIC;
        last: in STD_LOGIC;
        reset: in STD_LOGIC;
        start: in STD_LOGIC;
        add_en: out STD_LOGIC;
        add_oe: out STD_LOGIC;
        endproc: out STD_LOGIC;
        m_oe: out STD_LOGIC;
        m_we: out STD_LOGIC;
        pix_oe: out STD_LOGIC;
        pix_rg: out STD_LOGIC);
end;

architecture fsm_arch of fsm is


-- SYMBOLIC ENCODED state machine: Sreg0
type Sreg0_type is (DEC, ENDP, GBRST, INIT, RD, WR);
signal Sreg0: Sreg0_type;

begin
--concurrent signal assignments
--diagram ACTIONS;


Sreg0_machine: process (clock, reset)

begin

if reset='1' then
	Sreg0 <= GBRST;
elsif clock'event and clock = '1' then
	case Sreg0 is
		when DEC =>
			if last='1' then
				Sreg0 <= ENDP;
			elsif last='0' then
				Sreg0 <= INIT;
			end if;
		when ENDP =>
		when GBRST =>
			if start='0' then
				Sreg0 <= INIT;
			end if;
		when INIT =>
			Sreg0 <= RD;
		when RD =>
			Sreg0 <= WR;
		when WR =>
			Sreg0 <= DEC;
		when others =>
			null;
	end case;
end if;
end process;

-- signal assignment statements for combinatorial outputs
endproc_assignment:
endproc <= '1' when (Sreg0 = ENDP) else
           '0';

pix_oe_assignment:
pix_oe <= '1' when (Sreg0 = WR) else
          '0';

add_oe_assignment:
add_oe <= '1' when (Sreg0 = INIT) else
          '1' when (Sreg0 = RD) else
          '1' when (Sreg0 = WR) else
          '0';

m_we_assignment:
m_we <= '0' when (Sreg0 = WR) else
        '1';

m_oe_assignment:
m_oe <= '1' when (Sreg0 = WR) else
        '0';

pix_rg_assignment:
pix_rg <= '1' when (Sreg0 = RD) else
          '0';

add_en_assignment:
add_en <= '1' when (Sreg0 = WR) else
          '0';

end fsm_arch;
